"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpMitmProxyFacade = void 0;
const inversify_1 = require("inversify");
const http_mitm_proxy_1 = __importDefault(require("@bjowes/http-mitm-proxy"));
const url_ext_1 = require("../util/url.ext");
let HttpMitmProxyFacade = class HttpMitmProxyFacade {
    constructor() {
        this._ntlmProxyListening = false;
        this._ntlmProxy = (0, http_mitm_proxy_1.default)();
    }
    use(mod) {
        this._ntlmProxy.use(mod);
        return this;
    }
    listen(port) {
        return new Promise((resolve, reject) => this._ntlmProxy.listen({ host: "127.0.0.1", port: port, keepAlive: true, forceSNI: false }, (err) => {
            if (err) {
                return reject(err);
            }
            this._ntlmProxyListening = true;
            const addressInfo = this._ntlmProxy.address();
            resolve(url_ext_1.URLExt.addressInfoToUrl(addressInfo, "http:"));
        }));
    }
    close() {
        if (this._ntlmProxyListening) {
            this._ntlmProxy.close();
            this._ntlmProxyListening = false;
        }
    }
};
HttpMitmProxyFacade = __decorate([
    (0, inversify_1.injectable)(),
    __metadata("design:paramtypes", [])
], HttpMitmProxyFacade);
exports.HttpMitmProxyFacade = HttpMitmProxyFacade;
